local SF = LibSFUtils

local SL=Slasher
local ASST=Slasher.assts
local HOLS=Slasher.holiday_items
local OTHR=Slasher.other

--local ZOS_addSystemMsg = CHAT_SYSTEM.AddMessage
local ZOS_addSystemMsg = d

local cakes ={
	-- add new cakes to the top, so the newest unlocked one is used
	{ id = HOLS.JUBALEE_CAKE2024, year = 2024, },
	{ id = HOLS.JUBALEE_CAKE2023, year = 2023, },
	{ id = HOLS.JUBALEE_CAKE2022, year = 2022, },
	{ id = HOLS.JUBALEE_CAKE2021, year = 2021, },
	{ id = HOLS.JUBALEE_CAKE2020, year = 2020, },
	{ id = HOLS.JUBALEE_CAKE2019, year = 2019, },
	{ id = HOLS.JUBALEE_CAKE3,    year = 2018, },
	{ id = HOLS.JUBALEE_CAKE2,    year = 2017, },
	{ id = HOLS.JUBALEE_CAKE,     year = 2016, },
}

local defaults = {
	banker = ASST.CROW_BANKER,
	merchant = ASST.MERCHANT,
	decon = ASST.DECON,
	resummon = true,
}

local pets = {
	23304, 30631, 30636, 30641, 23319, 30647, 30652, 30657, 23316, 30664, 30669, 30674, -- familiars
	24613, 30581, 30584, 30587, 24636, 30592, 30595, 30598, 24639, 30618, 30622, 30626, -- twilights
	85982, 85983, 85984, 85985, 85986, 85987, 85988, 85989, 85990, 85991, 85992, 85993 -- grizzly bears
}

-- Create names for keybindings
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_RELOADUI', GetString(SL_BINDING_RELOADUI))
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_LEAVE', GetString(SL_BINDING_LEAVE))
--ZO_CreateStringId('SI_BINDING_NAME_SLASHER_DISBAND', GetString(SL_BINDING_DISBAND))
--ZO_CreateStringId('SI_BINDING_NAME_SLASHER_READY', GetString(SL_BINDING_READY))
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_GOHOME', 'Go Home')
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_GRASS', GetString(SL_BINDING_GRASS))
ZO_CreateStringId('SI_BINDING_NAME_ANTIQUARIAN_EYE', GetString(SL_BINDING_EYE))
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_DISMISS_PET', GetString(SL_BINDING_PETS))


ZO_CreateStringId('SI_BINDING_NAME_SLASHER_FAV_BANKER_TOGGLE', GetString(SL_FAV_BANKER))
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_FAV_MERCHANT_TOGGLE', GetString(SL_FAV_MERCHANT))

n = GetCollectibleInfo(ASST.DECON)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_DECON_TOGGLE', n)

n = GetCollectibleInfo(ASST.FARG_DECON)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_FARG_DECON_TOGGLE', n)

n = GetCollectibleInfo(ASST.BANKER)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_BANKER_TOGGLE', n)

n = GetCollectibleInfo(ASST.ALFIQ_BANKER)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_ALFIQBANKER_TOGGLE', n)

n = GetCollectibleInfo(ASST.CROW_BANKER)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_CROWBANKER_TOGGLE', n)

n = GetCollectibleInfo(ASST.CLOCK_BANKER)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_CLOCKBANKER_TOGGLE', n)

n = GetCollectibleInfo(ASST.MONST_BANKER)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_MONSTBANKER_TOGGLE', n)

n = GetCollectibleInfo(ASST.FENCE)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_FENCE_TOGGLE', n)
n = GetCollectibleInfo(ASST.MERCHANT)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_MERCHANT_TOGGLE', n)

n = GetCollectibleInfo(ASST.ALFIQ_MERCHANT)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_ALFIQMERCHANT_TOGGLE', n)

n = GetCollectibleInfo(ASST.CROW_MERCHANT)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_CROWMERCHANT_TOGGLE', n)

n = GetCollectibleInfo(ASST.CLOCK_MERCHANT)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_CLOCKMERCHANT_TOGGLE', n)

n = GetCollectibleInfo(ASST.MONST_MERCHANT)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_MONSTMERCHANT_TOGGLE', n)

n = GetCollectibleInfo(ASST.XYN_MERCHANT)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_XYNMERCHANT_TOGGLE', n)

n = GetCollectibleInfo(ASST.ARMORER)
ZO_CreateStringId('SI+BINDING_NAME_SLASHER_ARMORER_TOGGLE', n)

n = GetCollectibleInfo(ASST.ZUQOTH)
ZO_CreateStringId('SI+BINDING_NAME_SLASHER_ZUQOTH_TOGGLE', n)

n = GetCollectibleInfo(HOLS.BREDAS_MEAD_CUP)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_MEAD', n)

n = GetCollectibleInfo(HOLS.JUBALEE_CAKE2024)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_CAKE', n)

n = GetCollectibleInfo(HOLS.WITCHMOTHERS_WHISTLE)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_WITCH_WHISTLE', n)

n = GetCollectibleInfo(HOLS.PIE_OF_MISRULE)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_PIE', n)

n = GetCollectibleInfo(ASST.BASTIAN)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_BASTIAN_TOGGLE', n)

n = GetCollectibleInfo(ASST.MIRRI)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_MIRRI_TOGGLE', n)

n = GetCollectibleInfo(ASST.EMBER)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_EMBER_TOGGLE', n)

n = GetCollectibleInfo(ASST.ISOBEL)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_ISOBEL_TOGGLE', n)

n = GetCollectibleInfo(ASST.SHARP)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_SHARP_TOGGLE', n)

n = GetCollectibleInfo(ASST.AZANDAR)
ZO_CreateStringId('SI_BINDING_NAME_SLASHER_AZANDAR_TOGGLE', n)

n = GetCollectibleInfo(OTHR.ANTIQUARIAN_EYE)
ZO_CreateStringId('SI_BINDING_NAME_ANTIQUARIAN_EYE', n)

---------------------
local function internalMsg(text, textcolor)
	local prefix = SF.colors.bronze:Colorize("["..SL.name.."] ")
	local msg = textcolor:Colorize(text)
	ZOS_addSystemMsg(prefix..msg);
end
    
local function SystemMessage(text)
    internalMsg(text, SF.colors.mocassin)
end

local function DebugMessage(text)
	if(not SL.saved.debug) then return end
    internalMsg(text, SF.colors.ltskyblue)
end

----------
-- INIT --
----------
local function onPlayerActivated()
	EVENT_MANAGER:UnregisterForEvent(SL.name, EVENT_PLAYER_ACTIVATED)
end

local function onAddonLoaded(_, addonName)
	if addonName == SL.name then
		EVENT_MANAGER:UnregisterForEvent(SL.name, EVENT_ADD_ON_LOADED)
		
        aw, toon = SF.getAllSavedVars("SlasherVar", 1, defaults)
        SL.saved = SF.currentSavedVars(aw, toon)

		SL.RegisterSettings()
		EVENT_MANAGER:RegisterForEvent(SL.name, EVENT_PLAYER_ACTIVATED, onPlayerActivated)
	end
	
end

function Slasher.dismissPets()
	-- Walk through active buffs looking for the cancelables (likely pets)
	local i
	for i = 1, GetNumBuffs("player") do
		local buffName, _, _, buffSlot, _, _, _, _, _, _, abilityId, canClickOff = GetUnitBuffInfo("player", i)
		if canClickOff == true then
			--d("found possible pet: "..buffName)
			-- Compare each buff's abilityID to the list of IDs we were given
			local k, v
			for k, v in pairs(pets) do
				if abilityId == v then
					-- It is a pet so cancel it
					CancelBuff(buffSlot)
				end
			end
		end
	end
end

local function useCollectibleItem(item, errmsg)
	local name,description,icon,lockedIcon,unlocked,purchasable,isActive,Collectible,categoryType,hint,isPlaceholder=GetCollectibleInfo(item)
	if( unlocked == true ) then
		UseCollectible(item)
	elseif errmsg ~= nil then
		SystemMessage(errmsg)
	end
end

local function useCake(errmsg, year)
	local function getNewestCake()
		for _, cake in ipairs(cakes) do
			if IsCollectibleUnlocked(cake.id) then
				return cake.id
			end
		end
	end
	
	local function getYearCake(year)
		local yr = tonumber(year)
		for _, cake in ipairs(cakes) do
			if cake.year == yr and IsCollectibleUnlocked(cake.id) then
				return cake.id
			end
		end
	end
	id = nil
	if not year then
		id = getNewestCake()
	else
		id = getYearCake(year)
	end
	if id then
		UseCollectible(id)
		return
	end

	-- does not possess any of the cakes or not the specified year cake
	SystemMessage(errmsg)
end

local function isLeader()
    if GetGroupSize() > 1 and IsUnitGroupLeader(UNITTAG_PLAYER) then
		return true
	end
	return false
end

local function isInGroup()
    local groupSize = GetGroupSize()
	if groupSize > 1 then
		return true
	end
	return false
end

function SL.leaveGroup()
    if isInGroup() then
		GroupLeave()
	end
end

function SL.disbandGroup()
    if isInGroup() and IsUnitPlayer(GetGroupLeaderUnitTag()) then
		if not (IsActiveWorldBattleground() or IsInLFGGroup()) then
			GroupDisband()
		else
			SystemMessage(GetString(SLASHER_GROUP_ERROR))
		end
	end
end

function SL.readyCheck()
    if isInGroup() then
		ZO_SendReadyCheck()
	end
end



function SL.gohome()
	local primary = GetHousingPrimaryHouse()
	if( primary == nil ) then 
		SystemMessage(GetString(SLASHER_HOME_NO_PRIMARY))
		return 
	end
	local collectible=GetCollectibleIdForHouse(primary)
	local name,description,icon,lockedIcon,unlocked,purchasable,isActive,Collectible,categoryType,hint,isPlaceholder=GetCollectibleInfo(collectible)
	if( unlocked == true ) then
		SystemMessage(GetString(SLASHER_HOME_GOING_TO)..name)
		RequestJumpToHouse(primary)
	else
		SystemMessage(GetString(SLASHER_HOME_NOT_OWN)..name)
	end
end

function Slasher.togglegrass()
	--valid = { CLUTTER_QUALITY_OFF, CLUTTER_QUALITY_LOW, CLUTTER_QUALITY_MEDIUM, CLUTTER_QUALITY_HIGH, CLUTTER_QUALITY_ULTRA, }	
	local current = tonumber(GetSetting( SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_CLUTTER_2D_QUALITY ))
	local new = CLUTTER_QUALITY_MEDIUM
	if current ~= CLUTTER_QUALITY_OFF then 
		new = CLUTTER_QUALITY_OFF 
	end
	SetSetting( SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_CLUTTER_2D_QUALITY, new )
end

function Slasher.shutoffZOSSkyshards()
	RedirectTexture("EsoUI/Art/MapPins/skyshard_seen.dds", "/esoui/art/icons/heraldrycrests_misc_blank_01.dds")
	RedirectTexture("EsoUI/Art/Compass/skyshard_seen.dds", "/esoui/art/icons/heraldrycrests_misc_blank_01.dds")
end

function SL.reloadui()
    ReloadUI("ingame")
end


local function isAsstActive(id)
	if id == nil or id == 0 then return false end
	local name,description,icon,lockedIcon,unlocked,purchasable,isActive,Collectible,categoryType,hint,isPlaceholder=GetCollectibleInfo(id)
	return (unlocked and isActive)
end

local companion_active = 0
local function getActiveCompanion()
	if SL.saved.resummon == false then return 0 end
	
	local name,description,icon,lockedIcon,unlocked,purchasable,isActive,Collectible,categoryType,hint,isPlaceholder=GetCollectibleInfo(ASST.MIRRI)
	if isActive == true then
		return ASST.MIRRI
	end
	
	name,description,icon,lockedIcon,unlocked,purchasable,isActive,Collectible,categoryType,hint,isPlaceholder=GetCollectibleInfo(ASST.BASTIAN)
	if isActive == true then
		return ASST.BASTIAN
	end

	name,description,icon,lockedIcon,unlocked,purchasable,isActive,Collectible,categoryType,hint,isPlaceholder=GetCollectibleInfo(ASST.ISOBEL)
	if isActive == true then
		return ASST.ISOBEL
	end

	name,description,icon,lockedIcon,unlocked,purchasable,isActive,Collectible,categoryType,hint,isPlaceholder=GetCollectibleInfo(ASST.EMBER)
	if isActive == true then
		return ASST.EMBER
	end

	name,description,icon,lockedIcon,unlocked,purchasable,isActive,Collectible,categoryType,hint,isPlaceholder=GetCollectibleInfo(ASST.SHARP)
	if isActive == true then
		return ASST.SHARP
	end

	name,description,icon,lockedIcon,unlocked,purchasable,isActive,Collectible,categoryType,hint,isPlaceholder=GetCollectibleInfo(ASST.AZANDAR)
	if isActive == true then
		return ASST.AZANDAR
	end

	return companion_active
end

function SL.summon_banker(pid)
	local id = pid
	if pid == nil or type(pid) == "string" then 
		id = SL.saved.banker 
	end
	
	companion_active = getActiveCompanion()
	if isAsstActive(id) == true then
		-- dismissing
		if companion_active ~= 0 then
			useCollectibleItem(companion_active)
			companion_active = 0
		else
			useCollectibleItem(id,GetString(SLASHER_SERVICE_BANKER))
		end
	else
		useCollectibleItem(id,GetString(SLASHER_SERVICE_BANKER))
	end
end

function SL.summon_merchant(pid)
	local id = pid
	if pid == nil or type(pid) == "string" then 
		id = SL.saved.merchant 
	end
	companion_active = getActiveCompanion()
	if isAsstActive(id) == true then
		-- dismissing
		if companion_active ~= 0 then
			useCollectibleItem(companion_active)
			companion_active = 0
		else
			useCollectibleItem(id,GetString(SLASHER_SERVICE_MERCHANT))
		end
	else
		useCollectibleItem(id,GetString(SLASHER_SERVICE_MERCHANT))
	end
end

function SL.summon_armorer(pid)
	local id = pid
	if pid == nil or type(pid) == "string" then 
		id = SL.saved.armorer 
	end
	companion_active = getActiveCompanion()
	if isAsstActive(id) == true then
		-- dismissing
		if companion_active ~= 0 then
			useCollectibleItem(companion_active)
			companion_active = 0
		else
			useCollectibleItem(id,GetString(SLASHER_SERVICE_ARMORER))
		end
	else
		useCollectibleItem(id,GetString(SLASHER_SERVICE_ARMORER))
	end
end

function SL.summon_aadvisor(pid)
	local id = pid
	if pid == nil or type(pid) == "string" then 
		id = SL.saved.armorer 
	end
	companion_active = getActiveCompanion()
	if isAsstActive(id) == true then
		-- dismissing
		if companion_active ~= 0 then
			useCollectibleItem(companion_active)
			companion_active = 0
		else
			useCollectibleItem(id,GetString(SLASHER_SERVICE_ZUQOTH))
		end
	else
		useCollectibleItem(id,GetString(SLASHER_SERVICE_ZUQOTH))
	end
end

function SL.summon_decon(pid)
	local id = pid
	if pid == nil or type(pid) == "string" then 
		id = SL.saved.decon 
	end
	companion_active = getActiveCompanion()
	if isAsstActive(id) == true then
		-- dismissing
		if companion_active ~= 0 then
			useCollectibleItem(companion_active)
			companion_active = 0
		else
			useCollectibleItem(id,GetString(SLASHER_SERVICE_DECON))
		end
	else
		useCollectibleItem(id,GetString(SLASHER_SERVICE_DECON))
	end
end

local id2err = {
		[479] = SLASHER_ITEM_WHISTLE,
		[1167] = SLASHER_ITEM_PIE,
		[1168] = SLASHER_ITEM_MEADCUP,
		[356] =  SLASHER_ITEM_CAKE,		-- 2016
		[1109] = SLASHER_ITEM_CAKE,		-- 2017
		[4786] = SLASHER_ITEM_CAKE,		-- 2018
		[5886] = SLASHER_ITEM_CAKE,		-- 2019
		[7619] = SLASHER_ITEM_CAKE,		-- 2020
		[9012] = SLASHER_ITEM_CAKE,		-- 2021
		[10287] = SLASHER_ITEM_CAKE,	-- 2022
		[11089] = SLASHER_ITEM_CAKE,	-- 2023
		[12422] = SLASHER_ITEM_CAKE,	-- 2024
}

function SL.use_xp(pid)
	local id = pid
	if pid == nil or type(pid) == "string" then 
		id = SL.saved.event 
	end
	useCollectibleItem(id, GetString(id2err[id]))
end

function SL.use_memento(mid)
	--SystemMessage("use_memento with "..mid.." type = "..type(mid))
	local id = mid
	if id == nil then return end
	local n, _, _, _, unlk, _, actv = GetCollectibleInfo(id)
	if n and n ~= "" then
		--SystemMessage("found collectible info for "..id)
		if GetCollectibleCategoryType(id) == COLLECTIBLE_CATEGORY_TYPE_MEMENTO then
			if unlk == false then
				SystemMessage("memento "..id.." ("..n..") ".." is locked")
				
			else
				useCollectibleItem(id, "error trying to use collectible "..id)
			end
			
		else
			SystemMessage(id.." ("..n..") ".." is NOT a MEMENTO ")
		end
	else
		SystemMessage("could not find collectible info for "..id)
	end
end

function SL.armorer()
	SL.summon_armorer(ASST.ARMORER)
end

function SL.aadv()
	SL.summon_aadvisor(ASST.ZUQOTH)
end

function SL.decon()
	SL.summon_decon(ASST.DECON)
end

function SL.farg_decon()
	SL.summon_decon(ASST.FARG_DECON)
end

function SL.banker()
	SL.summon_banker(ASST.BANKER)
end

function SL.kbanker()
	SL.summon_banker(ASST.ALFIQ_BANKER)
end

function SL.cbanker()
	SL.summon_banker(ASST.CROW_BANKER)
end

function SL.clbanker()
	SL.summon_banker(ASST.CLOCK_BANKER)
end

function SL.mbanker()
	SL.summon_banker(ASST.MONST_BANKER)
end

function SL.fence()
	useCollectibleItem(ASST.FENCE,GetString(SLASHER_SERVICE_FENCE))
end

function SL.merchant()
	SL.summon_merchant(ASST.MERCHANT)
end

function SL.kmerchant()
	SL.summon_merchant(ASST.ALFIQ_MERCHANT)
end

function SL.cmerchant()
	SL.summon_merchant(ASST.CROW_MERCHANT)
end

function SL.clmerchant()
	SL.summon_merchant(ASST.CLOCK_MERCHANT)
end

function SL.mmerchant()
	SL.summon_merchant(ASST.MONST_MERCHANT)
end

function SL.xmerchant()
	SL.summon_merchant(ASST.XYN_MERCHANT)
end

function SL.mead()
	useCollectibleItem(HOLS.BREDAS_MEAD_CUP,GetString(SLASHER_ITEM_MEADCUP))
end

function SL.cake(year)
		useCake(GetString(HOLS.SLASHER_ITEM_CAKE), year)
end

function SL.whistle()
	useCollectibleItem(HOLS.WITCHMOTHERS_WHISTLE,GetString(SLASHER_ITEM_WHISTLE))
end

function SL.pie()
	useCollectibleItem(HOLS.PIE_OF_MISRULE,GetString(SLASHER_ITEM_PIE))
end

function SL.mow()
	SetSetting( SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_CLUTTER_2D_QUALITY, CLUTTER_QUALITY_OFF )
end

function SL.grow()
	SetSetting( SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_CLUTTER_2D_QUALITY, CLUTTER_QUALITY_MEDIUM )
end

function SL.shutup( )
	SetSetting(SETTING_TYPE_AUDIO, AUDIO_SETTING_AUDIO_ENABLED, "0")
	zo_callLater(function() SetSetting(SETTING_TYPE_AUDIO, AUDIO_SETTING_AUDIO_ENABLED, "1") end, 300)
end

function SL.bastian()
    useCollectibleItem(ASST.BASTIAN,GetString(SLASHER_SERVICE_BASTIAN))
end

function SL.ember()
    useCollectibleItem(ASST.EMBER,GetString(SLASHER_SERVICE_EMBER))
end

function SL.isobel()
    useCollectibleItem(ASST.ISOBEL,GetString(SLASHER_SERVICE_ISOBEL))
end

function SL.mirri()
    useCollectibleItem(ASST.MIRRI,GetString(SLASHER_SERVICE_MIRRI))
end

function SL.sharp()
    useCollectibleItem(ASST.SHARP,GetString(SLASHER_SERVICE_SHARP))
end

function SL.azandar()
    useCollectibleItem(ASST.AZANDAR,GetString(SLASHER_SERVICE_AZANDAR))
end

function SL.decon()
    useCollectibleItem(ASST.DECON,GetString(SLASHER_SERVICE_DECON))
end

function SL.farg_decon()
    useCollectibleItem(ASST.FARG_DECON,GetString(SLASHER_SERVICE_FARG_DECON))
end

function SL.antiquarian_eye()
	useCollectibleItem(OTHR.ANTIQUARIAN_EYE,GetString(SLASHER_ITEM_EYE))
end


EVENT_MANAGER:RegisterForEvent(SL.name, EVENT_ADD_ON_LOADED, onAddonLoaded)



SLASH_COMMANDS["/rl"] = SL.reloadui
SLASH_COMMANDS["/home"] = SL.gohome

-- Group slash commands
SLASH_COMMANDS["/leave"] = SL.leaveGroup
SLASH_COMMANDS["/disband"] = SL.disbandGroup
SLASH_COMMANDS["/check"] = SL.readyCheck

-- Assistant slash commands
SLASH_COMMANDS["/b"] = SL.summon_banker
SLASH_COMMANDS["/f"] = SL.fence
SLASH_COMMANDS["/m"] = SL.summon_merchant
SLASH_COMMANDS["/d"] = SL.summon_decon

SLASH_COMMANDS["/ob"] = SL.banker
SLASH_COMMANDS["/om"] = SL.merchant
SLASH_COMMANDS["/kb"] = SL.kbanker
SLASH_COMMANDS["/km"] = SL.kmerchant
SLASH_COMMANDS["/cb"] = SL.cbanker
SLASH_COMMANDS["/clb"] = SL.clbanker
SLASH_COMMANDS["/mb"] = SL.mbanker
SLASH_COMMANDS["/cm"] = SL.cmerchant
SLASH_COMMANDS["/clm"] = SL.clmerchant
SLASH_COMMANDS["/mm"] = SL.mmerchant
SLASH_COMMANDS["/arm"] = SL.armorer
SLASH_COMMANDS["/ghr"] = SL.armorer
SLASH_COMMANDS["/ghrasharog"] = SL.armorer
SLASH_COMMANDS["/aadv"] = SL.aadv
SLASH_COMMANDS["/zuq"] = SL.aadv
SLASH_COMMANDS["/zuqoth"] = SL.aadv
SLASH_COMMANDS["/giladil"] = SL.decon
SLASH_COMMANDS["/gil"] = SL.decon
SLASH_COMMANDS["/adr"] = SL.farg_decon
SLASH_COMMANDS["/aderene"] = SL.farg_decon
SLASH_COMMANDS["/rd"] = SL.decon
SLASH_COMMANDS["/fd"] = SL.farg_decon
SLASH_COMMANDS["/xyn"] = SL.xmerchant

-- Companion slash commands
SLASH_COMMANDS["/bas"] = SL.bastian
SLASH_COMMANDS["/mir"] = SL.mirri
SLASH_COMMANDS["/bastian"] = SL.bastian
SLASH_COMMANDS["/mirri"] = SL.mirri
SLASH_COMMANDS["/emb"] = SL.ember
SLASH_COMMANDS["/iso"] = SL.isobel
SLASH_COMMANDS["/ember"] = SL.ember
SLASH_COMMANDS["/isobel"] = SL.isobel
SLASH_COMMANDS["/sharp"] = SL.sharp
SLASH_COMMANDS["/sha"] = SL.sharp
SLASH_COMMANDS["/azandar"] = SL.azandar
SLASH_COMMANDS["/aza"] = SL.azandar

-- Holiday slash commands
--SLASH_COMMANDS["/xp"] = SL.use_xp
SLASH_COMMANDS["/mead"] = SL.mead
SLASH_COMMANDS["/jcake"] = function(year)
	if year == "" then year = nil end
	SL.cake(year)
end
SLASH_COMMANDS["/cake"] = function(year)
	if year == "" then year = nil end
	SL.cake(year)
end
SLASH_COMMANDS["/witch"] = SL.whistle
SLASH_COMMANDS["/pie"] = SL.pie

-- Grass commands
SLASH_COMMANDS["/mow"] = SL.mow
SLASH_COMMANDS["/grow"] = SL.grow
SLASH_COMMANDS["/grass"] = SL.togglegrass

-- Other commands
SLASH_COMMANDS["/shutup"] = SL.shutup
SLASH_COMMANDS["/nosky"] = SL.shutoffZOSSkyshards
SLASH_COMMANDS["/eye"] = SL.antiquarian_eye
SLASH_COMMANDS["/mem"] = SL.use_memento

-- Familiars and combat pets
SLASH_COMMANDS["/dismisspet"] = SL.dismissPets
SLASH_COMMANDS["/pet"] = SL.dismissPets
SLASH_COMMANDS["/pets"] = SL.dismissPets

-- developer slash commands

SLASH_COMMANDS["/run"] = function(...)
    SLASH_COMMANDS["/script"](...)
end

SLASH_COMMANDS["/sho"] = function(objectToOutput)
    SystemMessage(objectToOutput)
end


SLASH_COMMANDS["/collectibles"] = function(...)
    local n
    local start = select(1,...)
	if not start then 
		SystemMessage("/collectibles requires a start number as parameter")
		return
	end
    --local fin = select(2,...)
    for k = start, start+1000 do
        n = GetCollectibleInfo(k)
        if n then
            SystemMessage(k..". "..n)
        end
    end
end

SLASH_COMMANDS["/getassistant"] = function(...)
    local n
    local start = 1
    for k = start, start+25000 do
        n = GetCollectibleInfo(k)
        if n then
			if GetCollectibleCategoryType(k) == COLLECTIBLE_CATEGORY_TYPE_ASSISTANT then
				SystemMessage(k..". "..n)
			end
        end
    end
end

SLASH_COMMANDS["/getcompanion"] = function(...)
    local n
    local start = 1
    for k = start, start+20000 do
        n = GetCollectibleInfo(k)
        if n then
			if GetCollectibleCategoryType(k) == COLLECTIBLE_CATEGORY_TYPE_COMPANION then
				SystemMessage(k..". "..n)
			end
        end
    end
end

SLASH_COMMANDS["/getstyle"] = function(...)
    local n
    local start = 1
    for k = start, start+20000 do
        n = GetCollectibleInfo(k)
        if n then
			if GetCollectibleCategoryType(k) == COLLECTIBLE_CATEGORY_TYPE_OUTFIT_STYLE then
				SystemMessage(k..". "..n)
			end
        end
    end
end


SLASH_COMMANDS["/getmemento"] = function(...)
    local n
    local start = 1
    for k = start, start+20000 do
        n = GetCollectibleInfo(k)
        if n then
			if GetCollectibleCategoryType(k) == COLLECTIBLE_CATEGORY_TYPE_MEMENTO then
				SystemMessage(k..". "..n)
			end
        end
    end
end


SLASH_COMMANDS["/dev"] = function(...)
    for index = 1, GetTotalCollectiblesByCategoryType(COLLECTIBLE_CATEGORY_TYPE_COMPANION) do
        local collectibleId = GetCollectibleIdFromType(COLLECTIBLE_CATEGORY_TYPE_COMPANION, index)
        SystemMessage(collectibleId)
    end
end

SLASH_COMMANDS["/what"] = function(...)
	for k,v in pairs(SLASH_COMMANDS) do
		SystemMessage(tostring(k))
		SystemMessage(tostring(v))
	end
end

SLASH_COMMANDS["/buffs"] = function(...)
	local i, k, v
	
	-- Walk through the player's active buffs
	d("Number of buffs: "..GetNumBuffs("player"))
	for i = 1, GetNumBuffs("player") do
		local buffName, timeStarted, timeEnding, buffSlot, stackCount, iconFilename, buffType, effectType, abilityType, statusEffectType, abilityId, canClickOff = GetUnitBuffInfo("player", i)
		-- Compare each buff's abilityID to the list of IDs we were given
		--[[for k, v in pairs(petList) do
			if abilityId == v then
				-- Cancel the buff if we got a match
				CancelBuff(buffSlot)
			end
		end
		--]]
		d( buffName .. abilityId .. " "..abilityType)
		if canClickOff == true then
			d(buffSlot.."/stk ".. stackCount.."/ic ".. iconFilename.."/bt ".. buffType.."/et ".. effectType.."/set ".. statusEffectType.."/".. SF.bool2str(canClickOff))
		end
	end
end