local SF = LibSFUtils

Slasher = {
	name = "Slasher",
	author = "Shadowfen",
	version = "2.32",
	savedVarVersion = "1",
}
local SL=Slasher
SL.displayName = SF.GetIconized(SL.name, SF.colors.gold.hex)
SL.author = SF.GetIconized(SL.author, SF.colors.purple.hex)


-- 11876. Drinweth, Valenwood Armorer
-- 11877. Tzozabrar, Dwarven Deconstructor
-- 12413. Eri, Barking Banker
-- 12414. Xyn, Planar Purveyor
SL.assts = {
	FENCE = 300,
	
	-- Bankers
	BANKER = 267,
	ALFIQ_BANKER = 6376,
	CROW_BANKER = 8994,
	CLOCK_BANKER = 9743,
	MONST_BANKER = 11097,   -- Pyroclast
	ERI_BANKER = 12413,		-- Eri
	
	-- Merchants
	MERCHANT = 301,
	ALFIQ_MERCHANT = 6378,
	CROW_MERCHANT = 8995,
	CLOCK_MERCHANT = 9744,
	MONST_MERCHANT = 11059,	-- Hoarfrost
	XYN_MERCHANT = 12414,	-- Xyn
	
	-- deconstructors
	DECON = 10184,		-- Giladil
	FARG_DECON = 10617,	--Aderene
	TZOZ_DECON = 11877, -- Tzozabrar

	-- Companions
	BASTIAN = 9245,		-- 9440 is houseguest
	MIRRI = 9353,		-- 9441 is houseguest
	ISOBEL = 9912,
	EMBER = 9911,
	SHARP = 11113,
	AZANDAR = 11114,
	
	--Armorers
	ARMORER = 9745,
	GHRASHROG = 9745,
	ZUQOTH = 10618,
	DRINWETH = 11876,
}
SL.holiday_items = {
	JUBALEE_CAKE = 356,
	JUBALEE_CAKE2 = 1109,
	JUBALEE_CAKE3 = 4786,
	JUBALEE_CAKE2019 = 5886,
	JUBALEE_CAKE2020 = 7619,
	JUBALEE_CAKE2021 = 9012,
	JUBALEE_CAKE2022 = 10287,
	JUBALEE_CAKE2023 = 11089,
	JUBALEE_CAKE2024 = 12422,
	WITCHMOTHERS_WHISTLE = 479,
	SWORD_SWALLOWERS_BLADE = 597,
	JUGGLERS_KNIVES = 598,
	FIRE_BREATHERS_TORCHES = 600,
	MUDBALL_POUCH = 601,
	PIE_OF_MISRULE = 1167,
	BREDAS_MEAD_CUP = 1168,
}

SL.other = {
	ANTIQUARIAN_EYE = 8006,
}
SF.LoadLanguage(Slasher_localization_strings, "en")
